#include "Tag.h"

/* This is the list of tags known by the browser. It doesn't mean that
   all tags listed here are supported but information provided here is
   usefull for parsing.
   XXX This list is incomplete.
*/

const TagInfo TagInfo::tagInfos[] = {
/*	NAME		SPACE	SPACE	CLOSE MODE	REOPEN 
 *			BEFORE	AFTER
 */	{"/FONT",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/STRONG",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/BIG",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/SMALL",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/EM",		-1,	-1,	ALWAYS_CLOSE,	true},
	{" BR",		0,	-1,	NEVER_CLOSE,	true},
	{"/NOBR",	-1,	-1,	ALWAYS_CLOSE,	false},
	{" HR",		2,	0,	NEVER_CLOSE,	true},
	{"/P",		5,	0,	CAN_CLOSE,	false},
	{"/A",		-1,	-1,	ALWAYS_CLOSE,	true},
	{"/SPAN",	-1,	-1,	ALWAYS_CLOSE,	true},
	{" LINK",	-1,	-1,	NEVER_CLOSE,	true},
	{" META",	-1,	1,	NEVER_CLOSE,	true},
	{"/I",		-1,	-1,	ALWAYS_CLOSE,	true},
	{"/B",		-1,	-1,	ALWAYS_CLOSE,	true},
	{"/U",		-1,	-1,	ALWAYS_CLOSE,	true},
	{"/TT",		-1,	-1,	ALWAYS_CLOSE,	true},
	{"/LI",		0,	-1,	ALWAYS_CLOSE,	false},
	{"/DT",		0,	-1,	ALWAYS_CLOSE,	false},
	{"/DD",		0,	-1,	ALWAYS_CLOSE,	false},
	{"/DL",		0,	-1,	ALWAYS_CLOSE,	false},
	{"/UL",		0,	0,	ALWAYS_CLOSE,	true},
	{"/OL",		0,	0,	ALWAYS_CLOSE,	true},
	{"/H1",		6,	0,	ALWAYS_CLOSE,	false},
	{"/H2",		5,	0,	ALWAYS_CLOSE,	false},
	{"/H3",		4,	0,	ALWAYS_CLOSE,	false},
	{"/H4",		2,	0,	ALWAYS_CLOSE,	false},
	{"/H5",		1,	0,	ALWAYS_CLOSE,	false},
	{"/H6",		0,	0,	ALWAYS_CLOSE,	false},
	{"/SUP",	-1,	-1,	ALWAYS_CLOSE,	false}, // Reopen ?
	{"/SUB",	-1,	-1,	ALWAYS_CLOSE,	false}, // Reopen ?
	{" IMG",	-1,	-1,	NEVER_CLOSE,	true},
	{"/STRIKE",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/TD",		-1,	-1,	ALWAYS_CLOSE,	false},
	{"/TH",		0,	0,	ALWAYS_CLOSE,	false},
	{"/TR",		0,	0,	ALWAYS_CLOSE,	false},
	{"/TABLE",	5,	5,	ALWAYS_CLOSE,	true},
	{"/DIV",	0,	0,	ALWAYS_CLOSE,	true},
	{"/CENTER",	0,	0,	ALWAYS_CLOSE,	true},
	{"/SCRIPT",	-1,	-1,	NEVER_CLOSE,	false},	// due to a specific javascript parsing, this
												// tag is marked as NEVER_CLOSE
	{"/NOSCRIPT",	-1,	-1,	ALWAYS_CLOSE,	false},
	{" FRAME",	0,	-1,	NEVER_CLOSE,	false},
	{"/IFRAME",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/LAYER",	0,	0,	ALWAYS_CLOSE,	false},
	{"/NOLAYER",	0,	0,	ALWAYS_CLOSE,	false},
	{"/ILAYER",	0,	0,	ALWAYS_CLOSE,	true},
	{"/NOFRAMES",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/FRAMESET",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/INPUT",	-1,	-1,	CAN_CLOSE,	false},
	{" TEXTAREA",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/BUTTON",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/SELECT",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/OPTION",	-1,	-1,	CAN_CLOSE,	false},
	{"/FORM",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/PRE",	0,	-1,	ALWAYS_CLOSE,	true},
	{" !--",	-1,	-1,	NEVER_CLOSE,	true},
	{"/BODY",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/TITLE",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/HEAD",	-1,	-1,	ALWAYS_CLOSE,	true},
	{" BASE",	-1,	-1,	NEVER_CLOSE,	true},
	{" !DOCTYPE",	-1,	-1,	NEVER_CLOSE,	true},
	{"/HTML",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/STYLE",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/INS",	-1,	-1,	ALWAYS_CLOSE,	true}, // INS and DEL are used for revision control
	{"/DEL",	-1,	-1,	ALWAYS_CLOSE,	true}, // 
	{"/FIELDSET",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/LEGEND",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/CAPTION",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/OBJECT",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/COLGROUP",	-1,	-1,	ALWAYS_CLOSE,	false},
	{" COL",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/AREA",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/MAP",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/THEAD",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/TBODY",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/TFOOT",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/CITE",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/BLOCKQUOTE",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/ADDRESS",-1,	-1,	ALWAYS_CLOSE,	false},
	{"/CODE",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/ACRONYM",-1,	-1,	ALWAYS_CLOSE,	false},
	{"/Q",		-1,	-1,	ALWAYS_CLOSE,	true}, // Small quotes
	{" SPACER",	-1,	-1,	NEVER_CLOSE,	true},
	{"/SAMP",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/BASEFONT",	-1,	-1,	ALWAYS_CLOSE,	true},
	{"/BLINK",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/KBD",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/DFN",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/DIR",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/LISTING",-1,	-1,	ALWAYS_CLOSE,	false},
	{"/XMP",	-1,	-1,	ALWAYS_CLOSE,	false},		// This one is deprecated. I don't think I should implement it
	{"/VAR",	-1,	-1,	ALWAYS_CLOSE,	false},
	{" WBR",	-1,	-1,	NEVER_CLOSE,	false},
	{"/MENU",	1,	1,	ALWAYS_CLOSE,	false},
	{"/EMBED",	1,	1,	ALWAYS_CLOSE,	false},
	{" PARAM",	1,	1,	NEVER_CLOSE,	false},
#ifdef __sun
	/* This is just experimentation for DocBook (man) format (SGML-based) */
	{"/PARA",	1,	1,	ALWAYS_CLOSE,	false},
	{"/REFENTRY",	1,	1,	ALWAYS_CLOSE,	false},
	{"/REFSECT1",	1,	1,	ALWAYS_CLOSE,	false},
	{"/SCREEN",	1,	1,	ALWAYS_CLOSE,	false},
	{"/COMPUTEROUTPUT",	1,	1,	ALWAYS_CLOSE,	false},
	{"/COMMAND",	-1,	-1,	ALWAYS_CLOSE,	false},
	{"/OLINK",	1,	1,	ALWAYS_CLOSE,	false},
	{"/CITEREFENTRY",	1,	1,	ALWAYS_CLOSE,	false},
	{"/MANVOLNUM",	1,	1,	ALWAYS_CLOSE,	false},
	{"/REFENTRYTITLE",	1,	1,	ALWAYS_CLOSE,	false},
	{"/INFORMALTABLE",	1,	1,	ALWAYS_CLOSE,	false},
	{"/TGROUP",	1,	1,	ALWAYS_CLOSE,	false},
	{"/ROW",	1,	1,	ALWAYS_CLOSE,	false},
	{"/ENTRY",	1,	1,	ALWAYS_CLOSE,	false},
	{"/VARIABLELIST",	1,	1,	ALWAYS_CLOSE,	false},
	{"/LISTITEM",	1,	1,	ALWAYS_CLOSE,	false},
	{"/VARLISTENTRY",	1,	1,	ALWAYS_CLOSE,	false},
	{"/TERM",	1,	1,	ALWAYS_CLOSE,	false},
	{"/FILENAME",	1,	1,	ALWAYS_CLOSE,	false},
	{"/RETURNVALUE",	1,	1,	ALWAYS_CLOSE,	false},
	{"/REPLACEABLE",	1,	1,	ALWAYS_CLOSE,	false},
#endif
	{NULL},
};
